<?xml version="1.0" encoding="UTF-8"?>
<!--
  Licensed to the Apache Software Foundation (ASF) under one
  or more contributor license agreements.  See the NOTICE file
  distributed with this work for additional information
  regarding copyright ownership.  The ASF licenses this file
  to you under the Apache License, Version 2.0 (the
  "License"); you may not use this file except in compliance
  with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an
  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, either express or implied.  See the License for the
  specific language governing permissions and limitations
  under the License.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    
    <modelVersion>4.0.0</modelVersion>

    <parent>
        <groupId>org.apache.isis.core</groupId>
        <artifactId>isis</artifactId>
        <version>2.0.0-M1</version>
        <relativePath>../../pom.xml</relativePath>
    </parent>

    <groupId>org.apache.isis.mavendeps</groupId>
    <artifactId>isis-mavendeps-webapp</artifactId>

    <packaging>pom</packaging>

    <name>Apache Isis Maven Dependencies for Webapp</name>
    <description>
        Defines a module that can be used as a single dependency for running an Apache Isis webapp (Wicket, Restful Objects and Shiro security)
    </description>
    
    <profiles>
        <profile>
            <id>isis-mavendeps-webapp</id>
            <activation>
                <property>
                    <name>!skip.isis-mavendeps-webapp</name>
                </property>
            </activation>
        
            <dependencies>
                <dependency>
                    <groupId>org.apache.isis.core</groupId>
                    <artifactId>isis-core-viewer-wicket-impl</artifactId>
                </dependency>
                <dependency>
                    <groupId>org.apache.isis.core</groupId>
                    <artifactId>isis-core-viewer-restfulobjects-server</artifactId>
                </dependency>
                <dependency>
                    <groupId>org.apache.isis.core</groupId>
                    <artifactId>isis-core-security-shiro</artifactId>
                </dependency>
                <dependency>
                    <groupId>org.apache.isis.core</groupId>
                    <artifactId>isis-core-security</artifactId>
                </dependency>
            </dependencies>
        </profile>
        <profile>
            <id>isis-mavendeps-intellij</id>
            <activation>
                <property>
                    <name>idea.version</name>
                </property>
            </activation>
            <dependencies>
                <dependency>
                    <groupId>org.apache.isis.core</groupId>
                    <artifactId>isis-core-webserver</artifactId>
                </dependency>
            </dependencies>
        </profile>
        <profile>
            <id>isis-mavendeps-eclipse</id>
            <activation>
                <property>
                    <name>m2e.version</name>
                </property>
            </activation>
            <dependencies>
                <dependency>
                    <groupId>org.apache.isis.core</groupId>
                    <artifactId>isis-core-webserver</artifactId>
                </dependency>
            </dependencies>
        </profile>
    </profiles>
    
</project>
