/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */

package org.apache.isis.core.metamodel.facets.object.parseable;

import org.apache.isis.core.commons.exceptions.IsisApplicationException;

/**
 * Indicates that a value entry is not valid. Note the entry may still parse
 * correctly, but is does fulfil other other entry requirements.
 */
public class InvalidEntryException extends IsisApplicationException {
    private static final long serialVersionUID = 1L;

    public InvalidEntryException(final String message) {
        super(message);
    }

    public InvalidEntryException(final Throwable cause) {
        this("Invalid value", cause);
    }

    public InvalidEntryException(final String message, final Throwable cause) {
        super(message, cause);
    }
}
