package org.apache.isis.core.metamodel.services.swagger.internal;

import io.swagger.models.Response;
import io.swagger.models.properties.IntegerProperty;

/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
enum Caching {
    TRANSACTIONAL {
        @Override public void withHeaders(final Response response) {

        }
    },
    USER_INFO {
        @Override public void withHeaders(final Response response) {
            response
                    .header("Cache-Control",
                            new IntegerProperty()
                                    ._default(3600));
        }
    },
    NON_EXPIRING {
        @Override public void withHeaders(final Response response) {
            response
                    .header("Cache-Control",
                            new IntegerProperty()
                                    ._default(86400).description(Util.roSpec("2.13")));
        }
    };

    public abstract void withHeaders(final Response response);
}
