<?xml version="1.0" encoding="UTF-8"?>
<!--
  Licensed to the Apache Software Foundation (ASF) under one
  or more contributor license agreements.  See the NOTICE file
  distributed with this work for additional information
  regarding copyright ownership.  The ASF licenses this file
  to you under the Apache License, Version 2.0 (the
  "License"); you may not use this file except in compliance
  with the License.  You may obtain a copy of the License at
  
         http://www.apache.org/licenses/LICENSE-2.0
         
  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an
  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, either express or implied.  See the License for the
  specific language governing permissions and limitations
  under the License.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <parent>
        <groupId>org.apache.isis.core</groupId>
        <artifactId>isis</artifactId>
        <version>2.0.0-M1</version>
    </parent>

	<artifactId>isis-core-viewer-restfulobjects-applib</artifactId>
	<name>Apache Isis RestfulObjects Viewer AppLib</name>

    <properties>
        <jar-plugin.automaticModuleName>org.apache.isis.viewer.restfulobjects.applib</jar-plugin.automaticModuleName>
        <git-plugin.propertiesDir>org/apache/isis/viewer/restfulobjects/applib</git-plugin.propertiesDir>
    </properties>

    <dependencies>
        <!-- [ahuber] there is still the goal of removing guava from ro-applib -->    
    	<dependency>
            <groupId>com.google.guava</groupId>
            <artifactId>guava</artifactId>
        </dependency>

        <dependency>
            <groupId>log4j</groupId>
            <artifactId>log4j</artifactId>
        </dependency>
		
        <dependency>
            <groupId>org.apache.isis.core</groupId>
            <artifactId>isis-core-applib</artifactId>
        </dependency>

<!--    <dependency> -->
<!--        <groupId>org.jdom</groupId> -->
<!--        <artifactId>jdom</artifactId> -->
<!--    </dependency> -->
	    
        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-databind</artifactId>
        </dependency>
	
        <!-- TEST DEPENDENCIES -->
        <dependency>
            <groupId>org.apache.isis.core</groupId>
            <artifactId>isis-core-metamodel</artifactId>
            <scope>test</scope>
        </dependency>

        <dependency>
            <groupId>org.apache.isis.core</groupId>
            <artifactId>isis-core-unittestsupport</artifactId>
            <scope>test</scope>
        </dependency>

    </dependencies>

    <repositories>
        <!-- The artifact in the maven repository has been moved and causes a build failure. Using this setting gets the artifact allowing the build to work.  This fix should hopefully be temporary -->
        <repository>
          <id>java.net</id>
          <url>http://repo1.maven.org/maven2</url>
            <snapshots>
              <enabled>false</enabled>
            </snapshots>
        </repository>
    </repositories>

</project>
