/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */

package org.apache.isis.viewer.wicket.ui.components.layout.bs3;

import com.google.common.base.Strings;

import org.apache.wicket.MarkupContainer;

import org.apache.isis.applib.layout.grid.bootstrap3.BS3Element;
import org.apache.isis.applib.layout.grid.bootstrap3.BS3ElementAbstract;
import org.apache.isis.viewer.wicket.ui.util.CssClassAppender;

public class Util {

    private Util(){}

    public static void appendCssClassIfRequired(final MarkupContainer markupContainer, final BS3Element element) {
        final String cssClass = element.getCssClass();
        if(cssClass != null) {
            CssClassAppender.appendCssClassTo(markupContainer, cssClass);
        }
    }
    public static void appendCssClass(final MarkupContainer markupContainer, final BS3ElementAbstract element, final String existingCssClass) {
        final String cssClass = existingCssClass + (!Strings.isNullOrEmpty(element.getCssClass())? (" " + element.getCssClass()): "");
        CssClassAppender.appendCssClassTo(markupContainer, cssClass);
    }
}
